using System;
using System.Collections;
using System.ComponentModel;

namespace WindowsApplication4
{
    
    
    /// <summary>
    /// Strongly typed collection of WindowsApplication4.clsBase.
    /// </summary>
    public class clsBaseCollection : System.Collections.CollectionBase
    {
        
        /// <summary>
        /// Default constructor.
        /// </summary>
        public clsBaseCollection() : 
                base()
        {
        }
        
        /// <summary>
        /// Gets or sets the value of the WindowsApplication4.clsBase at a specific position in the clsBaseCollection.
        /// </summary>
        public WindowsApplication4.clsBase this[int index]
        {
            get
            {
                return ((WindowsApplication4.clsBase)(this.List[index]));
            }
            set
            {
                this.List[index] = value;
            }
        }
        
        /// <summary>
        /// Append a WindowsApplication4.clsBase entry to this collection.
        /// </summary>
        /// <param name="value">WindowsApplication4.clsBase instance.</param>
        /// <returns>The position into which the new element was inserted.</returns>
        public int Add(WindowsApplication4.clsBase value)
        {
            return this.List.Add(value);
        }
        
        /// <summary>
        /// Determines whether a specified WindowsApplication4.clsBase instance is in this collection.
        /// </summary>
        /// <param name="value">WindowsApplication4.clsBase instance to search for.</param>
        /// <returns>True if the WindowsApplication4.clsBase instance is in the collection; otherwise false.</returns>
        public bool Contains(WindowsApplication4.clsBase value)
        {
            return this.List.Contains(value);
        }
        
        /// <summary>
        /// Retrieve the index a specified WindowsApplication4.clsBase instance is in this collection.
        /// </summary>
        /// <param name="value">WindowsApplication4.clsBase instance to find.</param>
        /// <returns>The zero-based index of the specified WindowsApplication4.clsBase instance. If the object is not found, the return value is -1.</returns>
        public int IndexOf(WindowsApplication4.clsBase value)
        {
            return this.List.IndexOf(value);
        }
        
        /// <summary>
        /// Removes a specified WindowsApplication4.clsBase instance from this collection.
        /// </summary>
        /// <param name="value">The WindowsApplication4.clsBase instance to remove.</param>
        public void Remove(WindowsApplication4.clsBase value)
        {
            this.List.Remove(value);
        }
        
        /// <summary>
        /// Returns an enumerator that can iterate through the WindowsApplication4.clsBase instance.
        /// </summary>
        /// <returns>An WindowsApplication4.clsBase's enumerator.</returns>
        public new clsBaseCollectionEnumerator GetEnumerator()
        {
            return new clsBaseCollectionEnumerator(this);
        }
        
        /// <summary>
        /// Insert a WindowsApplication4.clsBase instance into this collection at a specified index.
        /// </summary>
        /// <param name="index">Zero-based index.</param>
        /// <param name="value">The WindowsApplication4.clsBase instance to insert.</param>
        public void Insert(int index, WindowsApplication4.clsBase value)
        {
            this.List.Insert(index, value);
        }
        
        /// <summary>
        /// Strongly typed enumerator of WindowsApplication4.clsBase.
        /// </summary>
        public class clsBaseCollectionEnumerator : System.Collections.IEnumerator
        {
            
            /// <summary>
            /// Current index
            /// </summary>
            private int _index;
            
            /// <summary>
            /// Current element pointed to.
            /// </summary>
            private WindowsApplication4.clsBase _currentElement;
            
            /// <summary>
            /// Collection to enumerate.
            /// </summary>
            private clsBaseCollection _collection;
            
            /// <summary>
            /// Default constructor for enumerator.
            /// </summary>
            /// <param name="collection">Instance of the collection to enumerate.</param>
            internal clsBaseCollectionEnumerator(clsBaseCollection collection)
            {
                _index = -1;
                _collection = collection;
            }
            
            /// <summary>
            /// Gets the WindowsApplication4.clsBase object in the enumerated clsBaseCollection currently indexed by this instance.
            /// </summary>
            public WindowsApplication4.clsBase Current
            {
                get
                {
                    if (((_index == -1) 
                                || (_index >= _collection.Count)))
                    {
                        throw new System.IndexOutOfRangeException("Enumerator not started.");
                    }
                    else
                    {
                        return _currentElement;
                    }
                }
            }
            
            /// <summary>
            /// Gets the current element in the collection.
            /// </summary>
            object IEnumerator.Current
            {
                get
                {
                    if (((_index == -1) 
                                || (_index >= _collection.Count)))
                    {
                        throw new System.IndexOutOfRangeException("Enumerator not started.");
                    }
                    else
                    {
                        return _currentElement;
                    }
                }
            }
            
            /// <summary>
            /// Reset the cursor, so it points to the beginning of the enumerator.
            /// </summary>
            public void Reset()
            {
                _index = -1;
                _currentElement = null;
            }
            
            /// <summary>
            /// Advances the enumerator to the next queue of the enumeration, if one is currently available.
            /// </summary>
            /// <returns>true, if the enumerator was succesfully advanced to the next queue; false, if the enumerator has reached the end of the enumeration.</returns>
            public bool MoveNext()
            {
                if ((_index 
                            < (_collection.Count - 1)))
                {
                    _index = (_index + 1);
                    _currentElement = this._collection[_index];
                    return true;
                }
                _index = _collection.Count;
                return false;
            }
				}
		}
}
